<?php
//
// μCMS
// (c) Marek Drápal
// http://klikva.cz/ucms/
//
// PHP >= 4.3.0 + IMAP funkce
//
//
// Toto je blesková implementace, která není příliš bezpečná (z principu
// to ani moc nejde) a je bez záruky... 
// Vše co je posláno e-mailem ze zprocesuje a smaže. Žádné zálohy.
//
// Fungování:
// * na adresu UZIVATEL (viz definice níže) se pošle e-mail
// * v předmětu e-mailu musí být pouze jedna z variant (vysvětlení níže):
//    head:stranka 
//    tail:stranka
//    replace:stranka
//    datahead:soubor
//    datatail:soubor
//    datareplace:soubor
//  * v těle e-mailu musí být pouze data, která se vkládají do stránky/souboru
//  * přílohy zatím nejsou implementovány
//  * aby bylo možno zprávu přijmout, musí být:
//    - odeslána z adresy FROM
//    - hlavička e-mailu musí obsahovat řetězec HEADER
//    - upravovaná stránka/soubor musí být v poli KUPRAVAM
//  * samozřejmě musí být správně nastaveno HESLO a IMAP 
//    (všechny definice viz níže)
//  * po zavolání tohoto skriptu se aktualizuje buď stránka "stranka" nebo
//    soubor "soubor" uvedený v předmětu e-mailu. Aktualizace probíhá jako:
//     - přidání na konec stránky/souboru (tail)
//     - přidání na začátek stránky/souboru (head) - hlavičky stránky
//     se zachovávají
//     - náhrada stránky/souboru (replace) - hlavičky stránky se zachovávají
//
// Vlastní skript je třeba volat z cronu a v případě, že na výstupu ze skriptu
// bude řetězec "Aktualizace:" tak se pak zavolá dávkově ucms.php
//
// Naskriptování lze provést např. pomocí muttu nebo mailx. Např:
// echo " * V neděli 12.10. 2020 navštíví náš sbor bratr senior. Pokud můžete, přineste prosím koláče, chlebíčky, buchty a záviny na společné občerstvení." | mutt ucms@klikva.cz -s "head:aktuality"
//
// definice IMAP serveru a slozky
define("IMAP","{imap.klikva.cz:993/imap/ssl}INBOX");
// IMAP uzivatel
define("UZIVATEL","ucms@klikva.cz");
// IMAP heslo
define("HESLO","XXXXXXXXXX");
// Odesilatel, ze ktereho musi byt zprava odeslana
define("FROM","marek@drapal.org");
// Retezec, ktery se musi objevovat v hlavicce (Perl regexp)
define("HEADER","/\(Authenticated sender: marek\@drapal.org\)/");
// Stranky a datove soubory, ktere je mozno upravovat
// oddeleno dvojteckou, musi byt na zacatku i na konci
define("KUPRAVAM",":aktuality:kalendar:novinky:");



// Definice adresaru shodne/okopirovane z uCMS (musi korespondovat)
// Zde jsou uloženy texty, ze kterých je generováno HTML
define("TXT","./txt");

// Zde jsou uloženy datové soubory, cokoliv binárního mimo obrázků
define("DAT","./dat");

// Zde jsou uloženy obrázky
define("IMG","./img");

// Zde jsou uloženy zálohy upravovaných textů z adresáře TXT
define("BKP","./bkp");

//funkce na vymazani emailu + info o zprave
function err_imap_delete ($chyba,$inbox,$email_number,$from,$subject,$zprava)
  {
  echo "Chyba: ".$chyba."    <br>\n";
  echo "Odesílatel: ".$from."   <br>\n";
  echo "Předmět: ".$subject."   <br>\n";
  echo "Zpráva: ".$zprava."   <br>\n";
  imap_delete($inbox,$email_number);
  imap_expunge($inbox);
  }
//funkce jako err_imap_delete v případě, že vše dopadlo dobře
function ok_imap_delete ($stranka,$inbox,$email_number)
  {
  echo "Aktualizace: $stranka   <br>\n";
  imap_delete($inbox,$email_number);
  imap_expunge($inbox);
  }
// otevreme IMAP ucet
$inbox = imap_open(IMAP, UZIVATEL, HESLO) or die('Nelze se připojit na IMAP server: ' . imap_last_error());

$pocet_zprav=imap_num_msg($inbox);
// jsou zde nejake zpravy ?
if ($pocet_zprav > 0) 
  {
  // neni jich tu moc?
  if (imap_num_msg($inbox) > 3)
    {
    imap_close($inbox);
    die('Chyba: Je tu moc zpráv, vypadá to na zahlcení.');
    }
  else
    {
    $emails = imap_search($inbox,'ALL');
    if ($emails) 
      {
      foreach($emails as $email_number) 
        {
        $header = imap_headerinfo($inbox, $email_number);
	$from = $header->from[0]->mailbox . "@" . $header->from[0]->host;
	$subject = imap_utf8($header->subject);
	$hlavicky = imap_fetchbody($inbox,$email_number,0);
	$zprava = imap_fetchbody($inbox,$email_number,1);
		
	// kontrola
	// neni neprustrelna, ale dalsi restrikce by byly na ukor
	// pohodlnosti a jednoduchosti
	if ($from != FROM)
	  {
	  err_imap_delete ("Nepovolený odesílatel",$inbox,$email_number,$from,$subject,$zprava);
	  }
	else
	  {
          if (preg_match(HEADER,$hlavicky))
            { 		      
	    $stranka=explode(':',$subject);
	    if ($stranka[0] == 'head' || $stranka[0] == 'tail' || $stranka[0] == 'replace' || $stranka[0] == 'datahead' || $stranka[0] == 'datatail' || $stranka[0] == 'datareplace')
	     {
	     if(preg_match("/:".$stranka[1].":/",KUPRAVAM))
	       {
	       if ($stranka[0] == 'datatail' || $stranka[0] == 'datahead' || $stranka[0] == 'datareplace')
		 {
	         $bkp=BKP.'/'.$stranka[1].'.'.time().'.bak';
  		 $file=DAT.'/'.$stranka[1];
  		 if (is_file($file))
                   {
		   // zazálohujeme	   
		   copy($file,$bkp);
		   if ($stranka[0] == 'datatail')
		     {
		     // načteme a přidáme na konec zprávu
		     file_put_contents($file,file_get_contents($file).$zprava);
		     }
		   if ($stranka[0] == 'datahead')
		     {
		     // načteme a přidáme na konec zprávu
		     file_put_contents($file,$zprava.file_get_contents($file));
		     }
		   if ($stranka[0] == 'datareplace')
		     {
		     // nahradíme data vlastní zprávou
		     file_put_contents($file,$zprava);
		     }
		   // hotovo, vymažeme zprávu
		   ok_imap_delete ($stranka[1],$inbox,$email_number);
                   }
		 else
		   {
		   err_imap_delete ("Soubor ".$stranka[1]." neexistuje",$inbox,$email_number,$from,$subject,$zprava);      
	           }
	         }
               if ($stranka[0] == 'tail' || $stranka[0] == 'head' || $stranka[0] == 'replace')
		 {
	         $bkp=BKP.'/'.$stranka[1].'.'.time().'.bak';
  		 $file=TXT.'/'.$stranka[1].'.txt';
  		 if (is_file($file))
                   {
		   // zazálohujeme	   
		   copy($file,$bkp);
		   // načteme a přidáme na konec zprávu
		   if ($stranka[0] == 'tail')
		     {	   
		     file_put_contents($file,file_get_contents($file).$zprava);
		     // hotovo, vymažeme zprávu
		     ok_imap_delete ($stranka[1],$inbox,$email_number);
		     }
		   // načteme a přidáme na začátek zprávu
		   if ($stranka[0] == 'head' || $stranka[0] == 'replace')
		     {	   
		     //nejprve se musíme vypořádat s hlavičkami	     
		     //inspirovano clean_headers z ucms.php
		     $text=file($file);
		     $line=0;
		     $hlavicka=array();
		     $length=count($text);
    		     while($line < $length &&
          		   preg_match("/^###/",$text[$line],$regs))
		     {
		       $hlavicka[$line]=$text[$line];
                       $line++;
                       }
                     $data=array_slice($text,$line);
		     if ($stranka[0] == 'head')
		       {
		       file_put_contents($file,implode($hlavicka).$zprava.implode($data));
		       // hotovo, vymažeme zprávu
		       ok_imap_delete ($stranka[1],$inbox,$email_number);
		       } 
		     if ($stranka[0] == 'replace')
		       {
		       file_put_contents($file,implode($hlavicka).$zprava);
		       // hotovo, vymažeme zprávu
		       ok_imap_delete ($stranka[1],$inbox,$email_number);
		       } 
		     }
                   }
		 else
		   {
		   err_imap_delete ("Stránka ".$stranka[1]." neexistuje",$inbox,$email_number,$from,$subject,$zprava);      
	           }
	         }
	       }
	     else
	       {
	       err_imap_delete ("Stránka ".$stranka[1]." není povolena k editaci.",$inbox,$email_number,$from,$subject,$zprava);
	       }

	     }
	   else
	     {
             err_imap_delete ("Špatně definovaná akce: ".$stranka[0],$inbox,$email_number,$from,$subject,$zprava);
	     }
	   }
	 else
	   {
           err_imap_delete ("Nesprávné hlavičky e-mailu.",$inbox,$email_number,$from,$subject,$zprava);
	   }
          }
        }
      }
    } 
  }
else
  {
  echo "Nejsou zpravy k procesovani.";
  }
imap_close($inbox);
?>
